## ros-foxy-controller-manager 0.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(controller_manager)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_core REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(controller_interface REQUIRED)
find_package(controller_manager_msgs REQUIRED)
find_package(hardware_interface REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)

add_library(controller_manager SHARED
  src/controller_manager.cpp
)
target_include_directories(controller_manager PRIVATE include)
ament_target_dependencies(controller_manager
  ament_index_cpp
  controller_interface
  controller_manager_msgs
  hardware_interface
  pluginlib
  rclcpp
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(controller_manager PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
# prevent pluginlib from using boost
target_compile_definitions(controller_manager PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

add_executable(ros2_control_node src/ros2_control_node.cpp)
target_include_directories(ros2_control_node PRIVATE include)
target_link_libraries(ros2_control_node controller_manager)
ament_target_dependencies(ros2_control_node
  controller_interface
  hardware_interface
  rclcpp
)

install(TARGETS controller_manager
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(TARGETS ros2_control_node
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include
)

install(PROGRAMS
  scripts/spawner.py
  scripts/unspawner.py
  DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(ros2_control_test_assets REQUIRED)

  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_uncrustify
    ament_cmake_cpplint
  )
  ament_lint_auto_find_test_dependencies()

  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()

  add_library(test_controller SHARED test/test_controller/test_controller.cpp)
  target_include_directories(test_controller PRIVATE include)
  target_link_libraries(test_controller controller_manager)
  target_compile_definitions(test_controller PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller/test_controller.xml)
  install(TARGETS test_controller
    DESTINATION lib
  )

  add_library(test_controller_failed_init SHARED test/test_controller_failed_init/test_controller_failed_init.cpp)
  target_include_directories(test_controller_failed_init PRIVATE include)
  target_link_libraries(test_controller_failed_init controller_manager)
  target_compile_definitions(test_controller_failed_init PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller_failed_init/test_controller_failed_init.xml)
  install(TARGETS test_controller_failed_init
    DESTINATION lib
  )

  ament_add_gmock(
    test_controller_manager
    test/test_controller_manager.cpp
  )
  target_include_directories(test_controller_manager PRIVATE include)
  target_link_libraries(test_controller_manager controller_manager test_controller)
  ament_target_dependencies(test_controller_manager ros2_control_test_assets)

  ament_add_gmock(
    test_load_controller
    test/test_load_controller.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_load_controller PRIVATE include)
  target_link_libraries(test_load_controller controller_manager test_controller test_controller_failed_init)
  ament_target_dependencies(test_load_controller ros2_control_test_assets)

  ament_add_gmock(
    test_controller_manager_srvs
    test/test_controller_manager_srvs.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_controller_manager_srvs PRIVATE include)
  target_link_libraries(test_controller_manager_srvs controller_manager test_controller)
  ament_target_dependencies(
    test_controller_manager_srvs
    controller_manager_msgs
    ros2_control_test_assets
  )

  add_library(test_controller_with_interfaces SHARED test/test_controller_with_interfaces/test_controller_with_interfaces.cpp)
  target_include_directories(test_controller_with_interfaces PRIVATE include)
  target_link_libraries(test_controller_with_interfaces controller_manager)
  target_compile_definitions(test_controller_with_interfaces PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller_with_interfaces/test_controller_with_interfaces.xml)
  install(TARGETS test_controller_with_interfaces
    DESTINATION lib
  )

  ament_add_gmock(
    test_release_interfaces
    test/test_release_interfaces.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_release_interfaces PRIVATE include)
  target_link_libraries(test_release_interfaces controller_manager test_controller_with_interfaces)
  ament_target_dependencies(test_release_interfaces ros2_control_test_assets)

  ament_add_gmock(
    test_spawner_unspawner
    test/test_spawner_unspawner.cpp
  )
  target_include_directories(test_spawner_unspawner PRIVATE include)
  target_link_libraries(test_spawner_unspawner controller_manager test_controller)
  ament_target_dependencies(test_spawner_unspawner ros2_control_test_assets)
endif()

# Install Python modules
ament_python_install_package(${PROJECT_NAME})

ament_export_libraries(
  controller_manager
)
ament_export_include_directories(
  include
)
ament_export_dependencies(
  controller_interface
  controller_manager_msgs
  hardware_interface
  pluginlib
  rclcpp
)
ament_package()

=== debian/changelog ===
ros-foxy-controller-manager (0.11.0-1focal) focal; urgency=high



 -- karsten <karsten@osrfoundation.org>  Tue, 02 Aug 2022 23:00:00 -0000

ros-foxy-controller-manager (0.10.1-1focal) focal; urgency=high



 -- karsten <karsten@osrfoundation.org>  Mon, 30 May 2022 23:00:00 -0000

ros-foxy-controller-manager (0.10.0-1focal) focal; urgency=high

  * added a fixed control period to loop (backport #647 <https://github.com/ros-controls/ros2_control/issues/647>) (#651 <https://github.com/ros-controls/ros2_control/issues/651>)
  * Contributors: Jack Center, Denis Štogl

 -- karsten <karsten@osrfoundation.org>  Wed, 23 Feb 2022 00:00:00 -0000

ros-foxy-controller-manager (0.9.0-1focal) focal; urgency=high

  * Make output of not available controllers nicer and make it informative. (#577 <https://github.com/ros-controls/ros2_control/issues/577>) (#578 <https://github.com/ros-controls/ros2_control/issues/578>)
    (cherry picked from commit a47a0347acd28a47b5095e4b206257e1520918ee)
    Co-authored-by: Denis Štogl <mailto:destogl@users.noreply.github.com>
  * feat: add colored output into spawner.py (#560 <https://github.com/ros-controls/ros2_control/issues/560>) (#563 <https://github.com/ros-controls/ros2_control/issues/563>)
    in order to highlight if controllers are loaded and configured and started.
    (cherry picked from commit afa0e01989e5b923e5c330f71d9270b30f03276d)
    Co-authored-by: Michael <mailto:50864015+fmros@users.noreply.github.com>
  * Contributors: mergify[bot]

 -- karsten <karsten@osrfoundation.org>  Mon, 20 Dec 2021 00:00:00 -0000

ros-foxy-controller-manager (0.8.1-1focal) focal; urgency=high

  * [ControllerManager] Fix method name upon fetching state of controller(s) (#526 <https://github.com/ros-controls/ros2_control/issues/526>)
  * Controller Manager should not crash when trying to start finalized or unconfigured controller (#461 <https://github.com/ros-controls/ros2_control/issues/461>) (#524 <https://github.com/ros-controls/ros2_control/issues/524>)
  * Contributors: Denis Štogl, Lovro Ivanov

 -- karsten <karsten@osrfoundation.org>  Sun, 24 Oct 2021 23:00:00 -0000

ros-foxy-controller-manager (0.8.0-1focal) focal; urgency=high

  * Use clang format as code formatter (#491 <https://github.com/ros-controls/ros2_control/issues/491>)
  * Use example urdf from the test_assests package. (#495 <https://github.com/ros-controls/ros2_control/issues/495>)
  * Separate controller manager test cases (#476 <https://github.com/ros-controls/ros2_control/issues/476>)
  * Add Controller Manager docs (#467 <https://github.com/ros-controls/ros2_control/issues/467>)
  * sort interfaces in resource manager (#483 <https://github.com/ros-controls/ros2_control/issues/483>)
  * Add pre-commit setup. (#473 <https://github.com/ros-controls/ros2_control/issues/473>)
  * Make controller_manager set controller's use_sim_time param when use_sim_time=True (#468 <https://github.com/ros-controls/ros2_control/issues/468>)
    * potential solution to controller_manager use_sim_time sharing issue
    * removed debug print statements
    * added INFO message to warn user that use_sim_time is being set automatically
  * Add load-only option into controller spawner (#427 <https://github.com/ros-controls/ros2_control/issues/427>)
  * Fixes for windows (#443 <https://github.com/ros-controls/ros2_control/issues/443>)
    * Fix building on windows
    * Fix MSVC linker error when building tests
    * Fix hang when loading controller on windows
    * Use better log for configuring controller
    * Be consistent with visibility control
    * Use try_lock throw exception on failure
  * Add an argument to define controller manager timeout (#444 <https://github.com/ros-controls/ros2_control/issues/444>)
  * Contributors: Akash, Bence Magyar, Darko Lukić, Denis Štogl, Karsten Knese, Simon Honigmann

 -- karsten <karsten@osrfoundation.org>  Fri, 27 Aug 2021 23:00:00 -0000

ros-foxy-controller-manager (0.7.1-1focal) focal; urgency=high

  * Use namespace in controller_manager (#435 <https://github.com/ros-controls/ros2_control/issues/435>)
  * Contributors: Jonatan Olofsson

 -- karsten <karsten@osrfoundation.org>  Mon, 14 Jun 2021 23:00:00 -0000

ros-foxy-controller-manager (0.7.0-1focal) focal; urgency=high



 -- karsten <karsten@osrfoundation.org>  Sat, 05 Jun 2021 23:00:00 -0000

ros-foxy-controller-manager (0.6.1-1focal) focal; urgency=high

  * Add missing dependency on controller_manager_msgs (#426 <https://github.com/ros-controls/ros2_control/issues/426>)
  * Contributors: Denis Štogl

 -- karsten <karsten@osrfoundation.org>  Sun, 30 May 2021 23:00:00 -0000

ros-foxy-controller-manager (0.6.0-1focal) focal; urgency=high

  * List controller claimed interfaces (#407 <https://github.com/ros-controls/ros2_control/issues/407>)
    * List controllers now also shows the claimed interfaces
    * Fixed tests that perform switches
    Successfull controller switches require more than one call to update()
    in order to update the controller list
    * Can now set the command interface configuration
    * Added checks for the claimed interfaces
  * Contributors: Jordan Palacios

 -- karsten <karsten@osrfoundation.org>  Sat, 22 May 2021 23:00:00 -0000

ros-foxy-controller-manager (0.5.0-1focal) focal; urgency=high

  * Make controller manager update rate optional (#404 <https://github.com/ros-controls/ros2_control/issues/404>)
  * Bump wait_for_service timeout to 10 seconds (#403 <https://github.com/ros-controls/ros2_control/issues/403>)
  * introduce --stopped for spawner (#402 <https://github.com/ros-controls/ros2_control/issues/402>)
  * hardware_interface mode switching using prepareSwitch doSwitch approach (#348 <https://github.com/ros-controls/ros2_control/issues/348>)
  * Avoid std::stringstream (#391 <https://github.com/ros-controls/ros2_control/issues/391>)
  * avoid deprecations (#393 <https://github.com/ros-controls/ros2_control/issues/393>)


=== debian/control ===
Source: ros-foxy-controller-manager
Section: misc
Priority: optional
Maintainer: karsten <karsten@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gmock, ros-foxy-ament-cmake-gtest, ros-foxy-ament-index-cpp, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-controller-interface, ros-foxy-controller-manager-msgs, ros-foxy-hardware-interface, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rcpputils, ros-foxy-ros2-control-test-assets, ros-foxy-ros2param, ros-foxy-ros2run, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-controller-manager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-index-cpp, ros-foxy-controller-interface, ros-foxy-controller-manager-msgs, ros-foxy-hardware-interface, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rcpputils, ros-foxy-ros2-control-test-assets, ros-foxy-ros2param, ros-foxy-ros2run, ros-foxy-ros-workspace
Description: Description of controller_manager

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-controller-manager//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
